#ifndef RICH_LOCKERS2_HEADER_STORAGE
#define RICH_LOCKERS2_HEADER_STORAGE

namespace RL2 {
	class CSel {
		const HWND m_hwnd;
		CHARRANGE m_crPrev;
	public:
		CSel(HWND h):m_hwnd(h) {
			m_crPrev.cpMax=m_crPrev.cpMin=0;
			SendMessage(m_hwnd,EM_EXGETSEL,0,(LPARAM)&m_crPrev);
		}
		~CSel() {
			CHARRANGE cr;
			cr.cpMax=cr.cpMin=0;
			SendMessage(m_hwnd,EM_EXGETSEL,0,(LPARAM)&cr);
			if (cr.cpMin!=m_crPrev.cpMin || cr.cpMax != m_crPrev.cpMax) {
				SendMessage(m_hwnd,EM_EXSETSEL,0,(LPARAM)&m_crPrev);
			}
		}
	};//class CSel

	class CReadOnly {
		const HWND m_hwnd;
		bool m_bPrevReadOnly;
	public:
		CReadOnly(HWND hwnd):m_hwnd(hwnd),m_bPrevReadOnly(false) {
			ASSERT(IsWindow(m_hwnd));
			const DWORD dwOptions=SendMessage(m_hwnd,EM_GETOPTIONS,0,0);
			m_bPrevReadOnly=(0!=(dwOptions & ECO_READONLY));
			if (m_bPrevReadOnly) {
				SendMessage(m_hwnd,EM_SETREADONLY,FALSE,0);
		#ifdef _DEBUG//
				const DWORD dwOptions=SendMessage(m_hwnd,EM_GETOPTIONS,0,0);
				const bool bTest=(0!=(dwOptions & ECO_READONLY));
				ASSERT(false == bTest);
		#endif
			}
		}//constructor
		~CReadOnly()
		{
			ASSERT(IsWindow(m_hwnd));
			if (m_bPrevReadOnly) {
				SendMessage(m_hwnd,EM_SETREADONLY,TRUE,0);
		#ifdef _DEBUG//
				const DWORD dwOptions=SendMessage(m_hwnd,EM_GETOPTIONS,0,0);
				const bool bTest=(0!=(dwOptions & ECO_READONLY));
				ASSERT(true== bTest);
		#endif

			}
		}
	};
}//namespace RL {

#endif//#ifndef RICH_LOCKERS2_HEADER_STORAGE